DevExtreme v25.2 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

JavaScript/jQuery Calendar - Multiple Selection

This demo applies different selection modes and date availability options to the JavaScript Calendar component.

Backend API
$(() => { const msInDay = 1000 * 60 * 60 * 24; const selectionModes = ['single', 'multiple', 'range']; const date = new Date().getTime(); const calendar = $('#calendar').dxCalendar({ value: [date, date + msInDay], showWeekNumbers: true, selectWeekOnClick: true, selectionMode: 'multiple', }).dxCalendar('instance'); $('#select-week').dxCheckBox({ text: 'Select week on click', value: true, onValueChanged(data) { calendar.option('selectWeekOnClick', data.value); }, }); $('#selection-mode').dxSelectBox({ dataSource: selectionModes, value: selectionModes[1], inputAttr: { 'aria-label': 'Selection Mode' }, onValueChanged(data) { calendar.option('selectionMode', data.value); }, }).dxSelectBox('instance'); $('#min-date').dxCheckBox({ text: 'Set minimum date', onValueChanged(data) { const minDate = new Date(date - msInDay * 3); calendar.option('min', data.value ? minDate : null); }, }); $('#max-date').dxCheckBox({ text: 'Set maximum date', onValueChanged(data) { const maxDate = new Date(date + msInDay * 3); calendar.option('max', data.value ? maxDate : null); }, }); $('#disable-dates').dxCheckBox({ text: 'Disable weekends', onValueChanged(data) { if (data.value) { calendar.option('disabledDates', (d) => d.view === 'month' && isWeekend(d.date)); } else { calendar.option('disabledDates', null); } }, }); $('#clear-button').dxButton({ text: 'Clear value', onClick: () => { calendar.clear(); }, }); function isWeekend(d) { const day = d.getDay(); return day === 0 || day === 6; } });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.3/css/dx.light.css" /> <script src="js/dx.all.js?v=25.2.3"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container" id="calendar-demo"> <div class="calendar-container"> <div id="calendar"></div> </div> <div class="options"> <div class="caption">Options</div> <div class="option"> <div id="select-week"></div> </div> <div class="option"> <span>Selection mode</span> <div id="selection-mode"></div> </div> <div class="caption option"> <span>Date availability</span> </div> <div class="option"> <div id="min-date"></div> </div> <div class="option"> <div id="max-date"></div> </div> <div class="option"> <div id="disable-dates"></div> </div> <div class="option"> <div id="clear-button"></div> </div> </div> </div> </body> </html>
#calendar-demo { display: flex; } .calendar-container { display: flex; flex-direction: column; flex-grow: 1; align-items: center; justify-content: center; } .caption { font-weight: 500; font-size: 18px; } .options { padding: 20px; background-color: rgba(191, 191, 191, 0.15); } .option { margin-top: 10px; }

Selection Modes

The selected value or values are stored in the value property. The following selection modes are available:

  • 'single'
    A user can select only a single date at any given time.

  • 'multiple'
    A user can select multiple dates simultaneously.

  • 'range'
    A user can select a range of dates. The first and the last date in the range are stored in the value property.

If you enable selectWeekOnClick in 'multiple' or 'range' modes, users can select a week by clicking on the week number.

Disable and Clear Dates

Use the min and max properties to specify the range of available dates. In this demo, these properties limit the range to three days before and after the current date. Enable the "Set minimum date" and "Set maximum date" checkboxes to apply the properties.

If you need to disable specific dates, use the disabledDates property. Toggle the "Disable weekends" checkbox to see how this setting affects component behavior. You can specify either an array of predefined dates or a function that determines whether a date is available.

When using 'multiple' and 'range' selection modes, the behavior of disabled dates in the JavaScript Calendar is as follows:

  • If you specify the value property programmatically, disabled dates are selected in the values array.

  • If you use the UI to change selection (click on dates or weeks, the Enter key), you cannot select disabled dates in 'multiple' mode. In 'range' mode, disabled dates cannot start or end a range, but can be included in the middle.

To clear selected values, call the JavaScript Calendar clear() method.

import React, { useCallback, useRef, useState } from 'react';
import CheckBox from 'devextreme-react/check-box';
import type { CheckBoxTypes } from 'devextreme-react/check-box';
import SelectBox from 'devextreme-react/select-box';
import type { SelectBoxTypes } from 'devextreme-react/select-box';
import Button from 'devextreme-react/button';
import Calendar from 'devextreme-react/calendar';
import type { CalendarTypes, CalendarRef } from 'devextreme-react/calendar';
const selectionModes = ['single', 'multiple', 'range'];
const selectionModeLabel = { 'aria-label': 'Selection Mode' };
const isWeekend = (date: Date): boolean => {
const day = date.getDay();
return day === 0 || day === 6;
};
const isDateDisabled = ({ view, date }: CalendarTypes.DisabledDate): boolean => view === 'month' && isWeekend(date);
const now = new Date().getTime();
const msInDay = 1000 * 60 * 60 * 24;
const initialValue = [now, now + msInDay];
export default function App() {
const calendar = useRef<CalendarRef>(null);
const [selectWeekOnClick, setSelectWeekOnClick] = useState<boolean>(true);
const [selectionMode, setSelectionMode] = useState<CalendarTypes.CalendarSelectionMode>('multiple');
const [minDateValue, setMinDateValue] = useState<Date | null>(null);
const [maxDateValue, setMaxDateValue] = useState<Date | null>(null);
const [weekendDisabled, setWeekendDisabled] = useState<boolean | null>(null);
const onSelectWeekOnClickChange = useCallback(({ value }: CheckBoxTypes.ValueChangedEvent): void => {
setSelectWeekOnClick(value);
}, [setSelectWeekOnClick]);
const onSelectionModeChange = useCallback(({ value }: SelectBoxTypes.ValueChangedEvent): void => {
setSelectionMode(value);
}, [setSelectionMode]);
const onMinDateChange = useCallback(({ value }: CheckBoxTypes.ValueChangedEvent): void => {
setMinDateValue(
value ? new Date(new Date().getTime() - 1000 * 60 * 60 * 24 * 3) : null,
);
}, [setMinDateValue]);
const onMaxDateChange = useCallback(({ value }: CheckBoxTypes.ValueChangedEvent): void => {
setMaxDateValue(
value ? new Date(new Date().getTime() + 1000 * 60 * 60 * 24 * 3) : null,
);
}, [setMaxDateValue]);
const onDisableWeekendChange = useCallback(({ value }: CheckBoxTypes.ValueChangedEvent): void => {
setWeekendDisabled(value);
}, [setWeekendDisabled]);
const onClearButtonClick = useCallback(() => {
calendar.current?.instance().clear();
}, []);
return (
<div id="calendar-demo">
<div className="calendar-container">
<Calendar
ref={calendar}
showWeekNumbers={true}
selectWeekOnClick={selectWeekOnClick}
selectionMode={selectionMode}
min={minDateValue}
max={maxDateValue}
defaultValue={initialValue}
disabledDates={weekendDisabled ? isDateDisabled : undefined}
/>
</div>
<div className="options">
<div className="caption">Options</div>
<div className="option">
<CheckBox
defaultValue={true}
text="Select week on click"
onValueChanged={onSelectWeekOnClickChange}
/>
</div>
<div className="option">
<span>Selection mode</span>
<SelectBox
dataSource={selectionModes}
value={selectionMode}
inputAttr={selectionModeLabel}
onValueChanged={onSelectionModeChange}
/>
</div>
<div className="option caption">
<span>Date availability</span>
</div>
<div className="option">
<CheckBox
defaultValue={false}
text="Set minimum date"
onValueChanged={onMinDateChange}
/>
</div>
<div className="option">
<CheckBox
defaultValue={false}
text="Set maximum date"
onValueChanged={onMaxDateChange}
/>
</div>
<div className="option">
<CheckBox
defaultValue={false}
text="Disable weekends"
onValueChanged={onDisableWeekendChange}
/>
</div>
<div className="option">
<Button
text="Clear value"
onClick={onClearButtonClick}
/>
</div>
</div>
</div>
);
}
import React, { useCallback, useRef, useState } from 'react';
import CheckBox from 'devextreme-react/check-box';
import SelectBox from 'devextreme-react/select-box';
import Button from 'devextreme-react/button';
import Calendar from 'devextreme-react/calendar';
const selectionModes = ['single', 'multiple', 'range'];
const selectionModeLabel = { 'aria-label': 'Selection Mode' };
const isWeekend = (date) => {
const day = date.getDay();
return day === 0 || day === 6;
};
const isDateDisabled = ({ view, date }) => view === 'month' && isWeekend(date);
const now = new Date().getTime();
const msInDay = 1000 * 60 * 60 * 24;
const initialValue = [now, now + msInDay];
export default function App() {
const calendar = useRef(null);
const [selectWeekOnClick, setSelectWeekOnClick] = useState(true);
const [selectionMode, setSelectionMode] = useState('multiple');
const [minDateValue, setMinDateValue] = useState(null);
const [maxDateValue, setMaxDateValue] = useState(null);
const [weekendDisabled, setWeekendDisabled] = useState(null);
const onSelectWeekOnClickChange = useCallback(
({ value }) => {
setSelectWeekOnClick(value);
},
[setSelectWeekOnClick],
);
const onSelectionModeChange = useCallback(
({ value }) => {
setSelectionMode(value);
},
[setSelectionMode],
);
const onMinDateChange = useCallback(
({ value }) => {
setMinDateValue(value ? new Date(new Date().getTime() - 1000 * 60 * 60 * 24 * 3) : null);
},
[setMinDateValue],
);
const onMaxDateChange = useCallback(
({ value }) => {
setMaxDateValue(value ? new Date(new Date().getTime() + 1000 * 60 * 60 * 24 * 3) : null);
},
[setMaxDateValue],
);
const onDisableWeekendChange = useCallback(
({ value }) => {
setWeekendDisabled(value);
},
[setWeekendDisabled],
);
const onClearButtonClick = useCallback(() => {
calendar.current?.instance().clear();
}, []);
return (
<div id="calendar-demo">
<div className="calendar-container">
<Calendar
ref={calendar}
showWeekNumbers={true}
selectWeekOnClick={selectWeekOnClick}
selectionMode={selectionMode}
min={minDateValue}
max={maxDateValue}
defaultValue={initialValue}
disabledDates={weekendDisabled ? isDateDisabled : undefined}
/>
</div>
<div className="options">
<div className="caption">Options</div>
<div className="option">
<CheckBox
defaultValue={true}
text="Select week on click"
onValueChanged={onSelectWeekOnClickChange}
/>
</div>
<div className="option">
<span>Selection mode</span>
<SelectBox
dataSource={selectionModes}
value={selectionMode}
inputAttr={selectionModeLabel}
onValueChanged={onSelectionModeChange}
/>
</div>
<div className="option caption">
<span>Date availability</span>
</div>
<div className="option">
<CheckBox
defaultValue={false}
text="Set minimum date"
onValueChanged={onMinDateChange}
/>
</div>
<div className="option">
<CheckBox
defaultValue={false}
text="Set maximum date"
onValueChanged={onMaxDateChange}
/>
</div>
<div className="option">
<CheckBox
defaultValue={false}
text="Disable weekends"
onValueChanged={onDisableWeekendChange}
/>
</div>
<div className="option">
<Button
text="Clear value"
onClick={onClearButtonClick}
/>
</div>
</div>
</div>
);
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.6.3/css/font-awesome.min.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#calendar-demo {
display: flex;
}
.calendar-container {
display: flex;
flex-direction: column;
flex-grow: 1;
align-items: center;
justify-content: center;
}
.caption {
font-weight: 500;
font-size: 18px;
}
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.option {
margin-top: 10px;
}

<div id="calendar-demo">
<div class="calendar-container">
<dx-calendar
#calendar
[value]="value"
[showWeekNumbers]="true"
[selectWeekOnClick]="true"
[selectionMode]="selectionMode"
[min]="minDateValue"
[max]="maxDateValue"
[disabledDates]="disabledDates"
>
</dx-calendar>
</div>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<dx-check-box
text="Select week on click"
[(value)]="calendar.selectWeekOnClick"
>
</dx-check-box>
</div>
<div class="option">
<span>Selection mode</span>
<dx-select-box
[dataSource]="selectionModes"
[(value)]="selectionMode"
[inputAttr]="{ 'aria-label': 'Selection Mode' }"
>
</dx-select-box>
</div>
<div class="caption option">
<span>Date availability</span>
</div>
<div class="option">
<dx-check-box
text="Set minimum date"
[value]="false"
(onValueChanged)="setMinDate($event)"
>
</dx-check-box>
</div>
<div class="option">
<dx-check-box
text="Set maximum date"
[value]="false"
(onValueChanged)="setMaxDate($event)"
>
</dx-check-box>
</div>
<div class="option">
<dx-check-box
text="Disable weekends"
[value]="false"
(onValueChanged)="disableWeekend($event)"
>
</dx-check-box>
</div>
<div class="option">
<dx-button text="Clear value" (onClick)="clearValue()"> </dx-button>
</div>
</div>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, ViewChild, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxSelectBoxModule, DxCheckBoxModule, DxButtonModule } from 'devextreme-angular';
import { DxCalendarComponent, DxCalendarModule, DxCalendarTypes } from 'devextreme-angular/ui/calendar';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
imports: [
DxSelectBoxModule,
DxCalendarModule,
DxCheckBoxModule,
DxButtonModule,
],
})
export class AppComponent {
@ViewChild(DxCalendarComponent, { static: false }) calendar: DxCalendarComponent;
now = new Date();
value = [new Date(), new Date(new Date().getTime() + 1000 * 60 * 60 * 24)];
selectionModes: DxCalendarTypes.CalendarSelectionMode[] = [
'single', 'multiple', 'range',
];
selectionMode: DxCalendarTypes.CalendarSelectionMode = 'multiple';
minDateValue: Date | null = null;
maxDateValue: Date | null = null;
disabledDates: Function | null = null;
isWeekend(date: Date) {
const day = date.getDay();
return day === 0 || day === 6;
}
setMinDate({ value }) {
this.minDateValue = value
? new Date(this.now.getTime() - 1000 * 60 * 60 * 24 * 3)
: null;
}
setMaxDate({ value }) {
this.maxDateValue = value
? new Date(this.now.getTime() + 1000 * 60 * 60 * 24 * 3)
: null;
}
disableWeekend({ value }) {
this.disabledDates = value
? (data: { view: string, date: Date }) => data.view === 'month' && this.isWeekend(data.date)
: null;
}
clearValue() {
this.calendar.instance.clear();
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep #calendar-demo {
display: flex;
}
.calendar-container {
display: flex;
flex-direction: column;
flex-grow: 1;
align-items: center;
justify-content: center;
}
.caption {
font-weight: 500;
font-size: 18px;
}
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.option {
margin-top: 10px;
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.0.2"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

<template>
<div id="calendar-demo">
<div class="calendar-container">
<DxCalendar
ref="calendarRef"
:value="initialValue"
:show-week-numbers="true"
:select-week-on-click="selectWeekOnClick"
:selection-mode="selectionMode"
:min="minDateValue"
:max="maxDateValue"
:disabled-dates="disabledDates"
/>
</div>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<DxCheckBox
v-model:value="selectWeekOnClick"
text="Select week on click"
/>
</div>
<div class="option">
<span>Selection mode</span>
<DxSelectBox
v-model:value="selectionMode"
:data-source="selectionModes"
:input-attr="{ 'aria-label': 'Selection Mode' }"
/>
</div>
<div class="option caption">
<span>Date availability</span>
</div>
<div class="option">
<DxCheckBox
:value="false"
text="Set minimum date"
@value-changed="setMinDate"
/>
</div>
<div class="option">
<DxCheckBox
:value="false"
text="Set maximum date"
@value-changed="setMaxDate"
/>
</div>
<div class="option">
<DxCheckBox
:value="false"
text="Disable weekends"
@value-changed="disableWeekend"
/>
</div>
<div class="option">
<DxButton
text="Clear value"
@click="clearValue"
/>
</div>
</div>
</div>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import DxCheckBox, { type DxCheckBoxTypes } from 'devextreme-vue/check-box';
import DxSelectBox from 'devextreme-vue/select-box';
import DxCalendar, { type DxCalendarTypes } from 'devextreme-vue/calendar';
import DxButton from 'devextreme-vue/button';
const calendarRef = ref();
const initialValue = [new Date(), new Date(new Date().getTime() + 1000 * 60 * 60 * 24)];
const selectWeekOnClick = ref(true);
const selectionMode = ref<DxCalendarTypes.CalendarSelectionMode>('multiple');
const minDateValue = ref();
const maxDateValue = ref();
const disabledDates = ref();
const selectionModes: DxCalendarTypes.CalendarSelectionMode[] = ['single', 'multiple', 'range'];
function isWeekend(date: Date) {
const day = date.getDay();
return day === 0 || day === 6;
}
function setMinDate({ value }: DxCheckBoxTypes.ValueChangedEvent) {
minDateValue.value = value
? new Date((new Date()).getTime() - 1000 * 60 * 60 * 24 * 3)
: null;
}
function setMaxDate({ value }: DxCheckBoxTypes.ValueChangedEvent) {
maxDateValue.value = value
? new Date((new Date()).getTime() + 1000 * 60 * 60 * 24 * 3)
: null;
}
function disableWeekend({ value }: DxCheckBoxTypes.ValueChangedEvent) {
disabledDates.value = value
? (data: Record<string, string | Date>) => data.view === 'month' && isWeekend(data.date as Date)
: null;
}
function clearValue() {
calendarRef.value.instance.clear();
}
</script>
<style scoped>
#calendar-demo {
display: flex;
}
.calendar-container {
display: flex;
flex-direction: column;
flex-grow: 1;
align-items: center;
justify-content: center;
}
.caption {
font-weight: 500;
font-size: 18px;
}
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.option {
margin-top: 10px;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.32/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'vue-loader': 'loaders:demo-vue-loader.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.6.3/css/font-awesome.min.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>